![shibori-hero](https://cloud.githubusercontent.com/assets/51578/22348697/b9929036-e3da-11e6-9863-10c734b5cf2b.png)

[Shibori](https://en.wikipedia.org/wiki/Shibori) is an HTML/CSS library used across Heroku marketing and web properties such as WWW and Elements Marketplace. View the library at [shibori.herokuapp.com](http://shibori.herokuapp.com)

## Local setup
Run:
```
script/bootstrap
```

To watch for files:
```
gulp serve
```

## Development alongside Rails
In the rails app, set up bundler to use the local copy of shibori you have: `bundle config local.shibori path/to/your/local/shibori`.

When you do local development you'll want the `local.shibori` set up. Before you deploy, you may want to remove this to test a specific tag.


```sh
# ~/.zshrc or ~/.bashrc example
alias shibori-on="bundle config local.shibori ../shibori"
alias shibori-off="bundle config --delete local.shibori"
```

## Pattern lab docs
Shibori uses the [node version](https://github.com/pattern-lab/patternlab-node) of [Pattern Lab](http://patternlab.io/). You can find documentation in this repo's [`docs`](/docs) directory.


## Release new gem version
- Update ```lib/shibori/version.rb``` with new version of Shibori
- Commit and merge into ```master``` branch
- Run ```rake release``` (you must be an owner of [Shibori on Rubygems.org](https://rubygems.org/gems/shibori))
